#!/bin/bash

# this script should be executed from the directory that contains the sonic-visualiser.app directory (application bundle)
# it copies the required 3rd party libraries into the application bundle and corrects the library install names and references

LIBPREFIX=/usr/local/lib/
QTPREFIX=/usr/local/Trolltech/Qt-4.1.0/lib/
TARGETPATH=sonic-visualiser.app/Contents/Frameworks/

mkdir $TARGETPATH

# add other required libs (e.g. oggz)
# use "otool -L <executable>" to get a list of required libraries

LIBS="libmad.0.2.1.dylib libsndfile.1.dylib libsamplerate.0.dylib libportaudio.dylib.0.0.18 liboggz.1.dylib libfishsound.1.dylib libvorbisenc.2.dylib libvorbis.0.dylib libogg.0.dylib"

# libjack.0.dylib  liblrdf.2.dylib libraptor.1.dylib

for LIB in $LIBS;
do
  cp $LIBPREFIX$LIB $TARGETPATH
done

for LIB in $LIBS;
do
  install_name_tool -id @executable_path/../Frameworks/${LIB} sonic-visualiser.app/Contents/Frameworks/${LIB}
done

for LIB in $LIBS;
do
  install_name_tool -change ${LIBPREFIX}${LIB} @executable_path/../Frameworks/${LIB}   sonic-visualiser.app/Contents/MacOS/sonic-visualiser
done

pushd $TARGETPATH

for LIB in $LIBS;
do
for TARGETLIB in $LIBS;
do
    install_name_tool -change ${LIBPREFIX}${TARGETLIB} @executable_path/../Frameworks/${TARGETLIB} $LIB
done
done

popd


# copy the dynamic libraries into the app bundle
cp ${QTPREFIX}QtXml.framework/Versions/4.0/QtXml ${TARGETPATH}
cp ${QTPREFIX}QtCore.framework/Versions/4.0/QtCore ${TARGETPATH}
cp ${QTPREFIX}QtGui.framework/Versions/4.0/QtGui ${TARGETPATH}

# change the id's of the dylibs
install_name_tool -id @executable_path/../Frameworks/QtXml sonic-visualiser.app/Contents/Frameworks/QtXml
install_name_tool -id @executable_path/../Frameworks/QtCore sonic-visualiser.app/Contents/Frameworks/QtCore
install_name_tool -id @executable_path/../Frameworks/QtGui sonic-visualiser.app/Contents/Frameworks/QtGui

# tell the linker to look for dylibs in the app bundle
install_name_tool -change ${QTPREFIX}QtCore.framework/Versions/4.0/QtCore @executable_path/../Frameworks/QtCore sonic-visualiser.app/Contents/MacOS/sonic-visualiser
install_name_tool -change ${QTPREFIX}QtGui.framework/Versions/4.0/QtGui @executable_path/../Frameworks/QtGui sonic-visualiser.app/Contents/MacOS/sonic-visualiser
install_name_tool -change ${QTPREFIX}QtXml.framework/Versions/4.0/QtXml @executable_path/../Frameworks/QtXml sonic-visualiser.app/Contents/MacOS/sonic-visualiser


# correct dependencies between QT dylibs
install_name_tool -change ${QTPREFIX}QtCore.framework/Versions/4.0/QtCore @executable_path/../Frameworks/QtCore   sonic-visualiser.app/Contents/Frameworks/QtXml
install_name_tool -change ${QTPREFIX}QtCore.framework/Versions/4.0/QtCore @executable_path/../Frameworks/QtCore   sonic-visualiser.app/Contents/Frameworks/QtGui

